> ## Documentation Index
> Fetch the complete documentation index at: https://stytch.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Create M2M Client

> Create a new M2M Client using the Stytch API

On initial client creation, you may pass in a custom `client_id` or `client_secret` to import an existing M2M client. If you do not pass in a custom `client_id` or `client_secret`, one will be generated automatically. The `client_id` must be unique among all clients in your project.

<Warning>
  This is the only time you will be able to view the generated `client_secret` in the API response. Stytch stores a hash of the `client_secret` and cannot recover the value if lost. Be sure to persist the `client_secret` in a secure location. If the `client_secret` is lost, you will need to trigger a secret rotation flow to receive another one.
</Warning>


## OpenAPI

````yaml POST /v1/m2m/clients
openapi: 3.0.3
info:
  title: Stytch API
  description: The Stytch API provides endpoints for authentication and user management.
  version: 2.1.1
  contact:
    name: Stytch Support
    url: https://stytch.com/docs
    email: support@stytch.com
servers:
  - url: https://api.stytch.com
    description: Production server
  - url: https://test.stytch.com
    description: Test server
security:
  - basicAuth: []
paths:
  /v1/m2m/clients:
    post:
      tags:
        - M2M
      summary: Create
      description: >-
        Creates a new M2M Client. On initial client creation, you may pass in a
        custom `client_id` or `client_secret` to import an existing M2M client.
        If you do not pass in a custom `client_id` or `client_secret`, one will
        be generated automatically. The `client_id` must be unique among all
        clients in your project.


        **Important:** This is the only time you will be able to view the
        generated `client_secret` in the API response. Stytch stores a hash of
        the `client_secret` and cannot recover the value if lost. Be sure to
        persist the `client_secret` in a secure location. If the `client_secret`
        is lost, you will need to trigger a secret rotation flow to receive
        another one.
      operationId: api_m2m_v1_m2m_clients_Create
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/api_m2m_v1_m2m_clients_CreateRequest'
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/api_m2m_v1_m2m_clients_CreateResponse'
        '400':
          description: Bad request
        '401':
          description: Unauthorized
          content:
            application/json:
              example:
                status_code: 401
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: unauthorized_credentials
                error_message: Unauthorized credentials.
                error_url: https://stytch.com/docs/api/errors/401
        '429':
          description: Too Many Requests
          content:
            application/json:
              example:
                status_code: 429
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: too_many_requests
                error_message: Too many requests have been made.
                error_url: https://stytch.com/docs/api/errors/429
        '500':
          description: Internal server error
          content:
            application/json:
              example:
                status_code: 500
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: internal_server_error
                error_message: >-
                  Oops, something seems to have gone wrong, please reach out to
                  support@stytch.com to let us know what went wrong.
                error_url: https://stytch.com/docs/api/errors/500
      x-code-samples:
        - lang: csharp
          label: C#
          source: |-
            // POST /v1/m2m/clients
            const stytch = require('stytch');

            const client = new stytch.B2BClient({
              project_id: '${projectId}',
              secret: '${secret}',
            });

            const params = {
              scopes: ["read:users", "write:users"],
              client_name: "My Sample Client",
              client_description: "My sample client for testing out M2M authentication.",
            };

            client.M2M.Clients.Create(params)
              .then(resp => { console.log(resp) })
              .catch(err => { console.log(err) });
        - lang: go
          label: Go
          source: "// POST /v1/m2m/clients\npackage main\n\nimport (\n\t\"context\"\n\t\"log\"\n\n\t\"github.com/stytchauth/stytch-go/v18/stytch/b2b/b2bstytchapi\"\n\t\"github.com/stytchauth/stytch-go/v18/stytch/consumer/m2m/clients\"\n)\n\nfunc main() {\n\tclient, err := b2bstytchapi.NewClient(\n\t\t\"${projectId}\",\n\t\t\"${secret}\",\n\t)\n\tif err != nil {\n\t\tlog.Fatalf(\"error instantiating client: %v\", err)\n\t}\n\n\tparams := &clients.CreateParams{\n\t\tScopes:            []string{\"read:users\", \"write:users\"},\n\t\tClientName:        \"My Sample Client\",\n\t\tClientDescription: \"My sample client for testing out M2M authentication.\",\n\t}\n\n\tresp, err := client.M2M.Clients.Create(context.Background(), params)\n\tif err != nil {\n\t\tlog.Fatalf(\"error in method call: %v\", err)\n\t}\n\n\tlog.Println(resp)\n}\n"
        - lang: java
          label: Java
          source: |-
            // POST /v1/m2m/clients
            package com.example;

            import com.stytch.java.b2b.StytchB2BClient;
            import com.stytch.java.common.StytchResult;
            import com.stytch.java.consumer.models.m2mclients.CreateRequest;

            public class Main {
                public static void main(String[] args) {
                    StytchB2BClient.configure("${projectId}", "${secret}");

                    CreateRequest params = new CreateRequest();
                    params.setScopes(new String("read:users", "write:users"));
                    params.setClientName("My Sample Client");
                    params.setClientDescription("My sample client for testing out M2M authentication.");

                    Object result = StytchB2BClient.getM2M().getClients().create(params);
                    if (result instanceof StytchResult.Success) {
                      System.out.println(((StytchResult.Success) result).getValue());
                    } else {
                      System.out.println(((StytchResult.Error) result).getException());
                    }
                }
            }
        - lang: kotlin
          label: Kotlin
          source: |
            // POST /v1/m2m/clients
            package com.example

            import com.stytch.java.b2b.StytchB2BClient
            import com.stytch.java.consumer.models.m2mclients.CreateRequest

            fun main() {
                StytchB2BClient.configure(
                    projectId = "${projectId}",
                    secret = "${secret}",
                )

                when (
                    val result =
                        StytchB2BClient.m2m.clients.create(
                            CreateRequest(
                                scopes = arrayOf("read:users", "write:users"),
                                clientName = "My Sample Client",
                                clientDescription = "My sample client for testing out M2M authentication.",
                            ),
                        )
                ) {
                    is StytchResult.Success -> println(result.value)
                    is StytchResult.Error -> println(result.exception)
                }
            }
        - lang: javascript
          label: Node.js
          source: |-
            // POST /v1/m2m/clients
            const stytch = require('stytch');

            const client = new stytch.B2BClient({
              project_id: '${projectId}',
              secret: '${secret}',
            });

            const params = {
              scopes: ["read:users", "write:users"],
              client_name: "My Sample Client",
              client_description: "My sample client for testing out M2M authentication.",
            };

            client.m2m.clients.create(params)
              .then(resp => { console.log(resp) })
              .catch(err => { console.log(err) });
        - lang: php
          label: PHP
          source: |-
            $response = $client->m2m->clients->create([
                'scopes' => ['read:users', 'write:users'],
                'client_name' => 'My Sample Client',
                'client_description' => 'My sample client for testing out M2M authentication.',
            ]);
        - lang: python
          label: Python
          source: |
            # POST /v1/m2m/clients
            from stytch import B2BClient

            client = B2BClient(
                project_id="${projectId}",
                secret="${secret}",
            )

            resp = client.m2m.clients.create(
                scopes=["read:users", "write:users"],
                client_name="My Sample Client",
                client_description="My sample client for testing out M2M authentication.",
            )

            print(resp)
        - lang: ruby
          label: Ruby
          source: |-
            # frozen_string_literal: true

            # POST /v1/m2m/clients
            require 'stytch'

            client = StytchB2B::Client.new(
              project_id: "${projectId}",
              secret: "${secret}"
            )

            resp = client.m2m.clients.create(
              scopes: ['read:users', 'write:users'],
              client_name: "My Sample Client",
              client_description: "My sample client for testing out M2M authentication."
              
            )

            puts resp
        - lang: rust
          label: Rust
          source: |-
            // POST /v1/m2m/clients
            use stytch::b2b::client::Client;
            use stytch::consumer::m2m_clients::CreateRequest;

            fn main() {
                let client = Client::new("${projectId}", "${secret}").unwrap();
                let resp = client.m2m.clients.create(
                    CreateRequest{
                        scopes: vec!["read:users", "write:users"],
                        client_name: Some(String::from("My Sample Client")),
                        client_description: Some(String::from("My sample client for testing out M2M authentication.")),
                        ..Default::default()
                    }
                ).await;
                println!("The response is {:?}", resp);
            }
        - lang: bash
          label: cURL
          source: |-
            # POST /v1/m2m/clients
            curl --request POST \
              --url https://test.stytch.com/v1/m2m/clients \
              -u '${projectId}:${secret}' \
              -H 'Content-Type: application/json' \
              -d '{
                "scopes": ["read:users", "write:users"],
                "client_name": "My Sample Client",
                "client_description": "My sample client for testing out M2M authentication."
              }'
components:
  schemas:
    api_m2m_v1_m2m_clients_CreateRequest:
      type: object
      properties:
        scopes:
          type: array
          items:
            type: string
          description: An array of scopes assigned to the client.
        client_id:
          type: string
          description: >-
            If provided, the ID of the client to create. If not provided, Stytch
            will generate this value for you. The `client_id` must be unique
            within your project.
        client_secret:
          type: string
          description: >-
            If provided, the stored secret of the client to create. If not
            provided, Stytch will generate this value for you. If provided, the
            `client_secret` must be at least 8 characters long and pass entropy
            requirements.
        client_name:
          type: string
          description: A human-readable name for the client.
        client_description:
          type: string
          description: A human-readable description for the client.
        trusted_metadata:
          type: object
          additionalProperties: true
          description: >-
            The `trusted_metadata` field contains an arbitrary JSON object of
            application-specific data. See the
            [Metadata](https://stytch.com/docs/api/metadata) reference for
            complete field behavior details.
      description: Request type
      required:
        - scopes
    api_m2m_v1_m2m_clients_CreateResponse:
      type: object
      properties:
        request_id:
          type: string
          description: >-
            Globally unique UUID that is returned with every API call. This
            value is important to log for debugging purposes; we may ask for
            this value to help identify a specific API call when helping you
            debug an issue.
        m2m_client:
          $ref: '#/components/schemas/api_m2m_v1_M2MClientWithClientSecret'
          description: The M2M Client created by this API call.
        status_code:
          type: integer
          format: int32
          description: >-
            The HTTP status code of the response. Stytch follows standard HTTP
            response status code patterns, e.g. 2XX values equate to success,
            3XX values are redirects, 4XX are client errors, and 5XX are server
            errors.
      required:
        - request_id
        - m2m_client
        - status_code
    api_m2m_v1_M2MClientWithClientSecret:
      type: object
      properties:
        client_id:
          type: string
          description: The ID of the client.
        client_secret:
          type: string
          description: >-
            The secret of the client. **Important:** this is the only time you
            will be able to view the `client_secret`. Be sure to persist the
            `client_secret` in a secure location. If the `client_secret` is
            lost, you will need to trigger a secret rotation flow to receive
            another one.
        client_name:
          type: string
          description: A human-readable name for the client.
        client_description:
          type: string
          description: A human-readable description for the client.
        status:
          type: string
          description: The status of the client - either `active` or `inactive`.
        scopes:
          type: array
          items:
            type: string
          description: An array of scopes assigned to the client.
        client_secret_last_four:
          type: string
          description: The last four characters of the client secret.
        trusted_metadata:
          type: object
          additionalProperties: true
          description: An arbitrary JSON object for storing application-specific data.
        next_client_secret_last_four:
          type: string
          description: >-
            The last four characters of the `next_client_secret`. Null if no
            `next_client_secret` exists.
      required:
        - client_id
        - client_secret
        - client_name
        - client_description
        - status
        - scopes
        - client_secret_last_four
  securitySchemes:
    basicAuth:
      type: http
      scheme: basic

````